//
//  FFStringBoundsOperation.h
//  AnimateTextLayers
//
//  Created by Jörgen Isaksson on 2015-03-29.
//  Copyright (c) 2015 Bitfield AB. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol FFStringBoundsOperationDelegate
// list of methods and properties
- (void)updateStringBounds:(NSArray *)boundsArray;
@end

@interface FFStringBoundsOperation : NSOperation

@property (weak) id<FFStringBoundsOperationDelegate> delegate;

@property (strong) NSArray *strings;
@property (assign) CGSize maxSize;

- (id)initWithStrings:(NSArray *)strings forMaxSize:(CGSize)maxSize;

@end
